<?php
/**
 * Clase Base FN para BaseArCuentaFN
 *
 * @package    
 * @subpackage BaseArCuentaFN
 * @author     Willy
 * @version    SVN:: BaseArCuentaFN.class.php,v 1.1 2020-06-30 13:51:23 william.taype Exp $
 */
class BaseArCuentaFN extends ArCuentaBN
{
  private static $fieldNames = array (
    'Idcuenta'=>'idcuenta', 'Tipo'=>'tipo', 'Titular'=>'titular', 'Moneda'=>'moneda', 'Numero'=>'numero', 'Idbanco'=>'idbanco', 'Estado'=>'estado', 'Eliminado'=>'eliminado', 'Fechaeliminado'=>'fechaeliminado', 'Usuarioeliminado'=>'usuarioeliminado'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idcuenta, tipo, titular, moneda, numero, idbanco, estado, eliminado, fechaeliminado, usuarioeliminado,usuariocreacion,fechacreacion, fechamodificacion, usuariomodificacion FROM ar_cuenta WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
	  
         $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idcuenta, tipo, titular, moneda, numero, idbanco, estado, eliminado, fechaeliminado, usuarioeliminado,usuariocreacion, fechacreacion  FROM ar_cuenta WHERE 1 ".$where;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdcuenta()){ $where .= " AND idcuenta = '".$this->getIdcuenta()."'"; }
      if($this->getTipo()){ $where .= " AND tipo = '".$this->getTipo()."'"; }
      if($this->getTitular()){ $where .= " AND titular = '".$this->getTitular()."'"; }
      if($this->getMoneda()){ $where .= " AND moneda = '".$this->getMoneda()."'"; }
      if($this->getNumero()){ $where .= " AND numero = '".$this->getNumero()."'"; }
      if($this->getIdbanco()){ $where .= " AND idbanco = '".$this->getIdbanco()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getFechaeliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaeliminado()."'"; }
      if($this->getUsuarioeliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioeliminado()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcuenta, tipo, titular, moneda, numero, idbanco, estado, eliminado, fechaeliminado, usuarioeliminado,usuariocreacion, fechacreacion  FROM ar_cuenta WHERE 1 AND idcuenta='".$this->getIdcuenta()."'; ";
         $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseArCuentaFN = new BaseArCuentaFN();
    $o_BaseArCuentaFN->setIdcuenta($o_propel->idcuenta);
    $o_BaseArCuentaFN->setTipo($o_propel->tipo);
    $o_BaseArCuentaFN->setTitular($o_propel->titular);
    $o_BaseArCuentaFN->setMoneda($o_propel->moneda);
    $o_BaseArCuentaFN->setNumero($o_propel->numero);
    $o_BaseArCuentaFN->setIdbanco($o_propel->idbanco);
    $o_BaseArCuentaFN->setEstado($o_propel->estado);
    $o_BaseArCuentaFN->setEliminado($o_propel->eliminado);
    $o_BaseArCuentaFN->setFechaeliminado($o_propel->fechaeliminado);
    $o_BaseArCuentaFN->setUsuarioeliminado($o_propel->usuarioeliminado);
	$o_BaseArCuentaFN->setUsuariocreacion($o_propel->usuariocreacion);
    $o_BaseArCuentaFN->setFechacreacion($o_propel->fechacreacion);
    $o_BaseArCuentaFN->setFechamodificacion($o_propel->fechamodificacion);
    $o_BaseArCuentaFN->setUsuariomodificacion($o_propel->usuariomodificacion);
    return $o_BaseArCuentaFN;
  }
}